cache_store_log /var/log/squid3/store.log

acl Safe_ports port 80		# http

acl allow_ip src {LAN_NETWORK}

acl badurl url_regex -i icloud-analysis.com

acl CONNECT method CONNECT
http_access deny badurl
http_access deny !Safe_ports
http_access deny CONNECT !Safe_ports
http_access allow localhost manager
http_access allow allow_ip
http_access deny all

http_port 0.0.0.0:{PROXY_PORT} transparent
forwarded_for delete

coredump_dir /var/spool/squid3
dns_nameservers 127.0.0.1 
dns_v4_first on
visible_hostname trueword-router 
#tcp_outgoing_address 182.92.224.15
strip_query_terms off 

cache_dir ufs /dev/shm 512 16 256
cache_mem 512 MB
maximum_object_size 4096 KB

refresh_pattern -i \.css$ 1440 50% 2880  override-expire override-lastmod reload-into-ims ignore-reload ignore-no-cache ignore-private
#refresh_pattern -i \.html$ 1440 90% 129600 override-expire override-lastmod reload-into-ims ignore-reload ignore-no-cache ignore-private
#refresh_pattern -i \.shtml$ 1440 90% 129600 override-expire override-lastmod reload-into-ims ignore-reload ignore-no-cache ignore-private
refresh_pattern -i \.png$ 1440 90% 129600 override-expire override-lastmod reload-into-ims ignore-reload ignore-no-cache ignore-private
refresh_pattern -i \.gif$ 1440 90% 129600 override-expire override-lastmod reload-into-ims ignore-reload ignore-no-cache ignore-private
refresh_pattern -i \.bmp$ 1440 90% 129600 override-expire override-lastmod reload-into-ims ignore-reload ignore-no-cache ignore-private

refresh_pattern -i \.js$ 1440 90% 2880 override-expire override-lastmod reload-into-ims ignore-reload ignore-no-cache ignore-private
refresh_pattern -i \.jpg$ 1440 90% 2880 override-expire override-lastmod reload-into-ims ignore-reload ignore-no-cache ignore-private

refresh_pattern -i \.mp3$ 1440 50% 2880 override-expire override-lastmod reload-into-ims ignore-reload ignore-no-cache ignore-private
refresh_pattern -i \.wmv$ 1440 50% 2880 override-expire override-lastmod reload-into-ims ignore-reload ignore-no-cache ignore-private
refresh_pattern -i \.rm$ 1440 50% 2880 override-expire override-lastmod reload-into-ims ignore-reload ignore-no-cache ignore-private
refresh_pattern -i \.swf$ 1440 50% 2880 override-expire override-lastmod reload-into-ims ignore-reload ignore-no-cache ignore-private
refresh_pattern -i \.mpeg$ 1440 50% 2880 override-expire override-lastmod reload-into-ims ignore-reload ignore-no-cache ignore-private
refresh_pattern -i \.wma$ 1440 50% 2880 override-expire override-lastmod reload-into-ims ignore-reload ignore-no-cache ignore-private


